function dx = Dynamic_behavior(t,x,mutant,D,S_f_GLCex,S_f_XYLex,a,called_by_ode15s)

pgi_mutant = mutant(1);
ptsG_mutant = mutant(2);

dx = zeros(43,1);

OD = x(1);
GLC_ex = x(2);
XYL_ex = x(3);
ACT_ex = x(4);
G6P = x(42);
F6P = x(5);
FBP = x(6);
PG3 = x(7);
PEP = x(8);
PYR = x(9); 
ACoA = x(10);
ICT = x(11);
AKG = x(12);
MAL = x(13);
OAA = x(14);
GLX = x(15);
PG6 = x(16);
Ribu5 = x(17);
Xyl5 = x(18);
Rib5 = x(19);
S7P = x(20);
E4P = x(21);
XYLin = x(22);
Xylu = x(23);
GLCin = x(24);
EIIA = x(25);
EIIA_P = x(26);
cAMP = x(27);
CrpcAMP = x(28);
CraFBP = x(29);
PdhRPYR = x(30);
SUC = x(31);
LAC = x(32);
AcAld = x(33);
ETH = x(34);
FOR = x(35);
QH2 = x(36);
Q = x(37);
NADH = x(38);
SUC_ex = x(39);
NADPH = x(40);
O2 = x(41);
KDPG = x(43);
    
Parameter

%% Concentration
% Crp
   Crp  = Crp_total - CrpcAMP;
% Cra
   Cra  = Cra_total - CraFBP;
% PdhR
   PdhR = PdhR_total - PdhRPYR;
% NAD
   NAD = NADH_NAD_total - NADH;
   
%% TF activity
% cAMPCrp
   TF_CrpcAMP = (CrpcAMP^n_CrpcAMP)/(CrpcAMP^n_CrpcAMP+K_CrpcAMP^n_CrpcAMP);
% Cra
   TF_Cra = Cra/(Cra+K_Cra);
% PdhR
   TF_PdhR = PdhR/(PdhR+K_PdhR);
% IclR
   TF_IclR = (PYR^n_IclR_PYR)/(K_IclR_PYR^n_IclR_PYR+PYR^n_IclR_PYR) - (GLX^n_IclR_GLX)/(K_IclR_GLX^n_IclR_GLX+GLX^n_IclR_GLX);
% Fnr
   TF_Fnr = (O2^n_FNR)/(K_A_FNR_O2^n_FNR+O2^n_FNR);
% ArcA
   TF_ArcA = (Q^n_ArcA)/(K_A_ArcA_Q^n_ArcA+Q^n_ArcA);
% XylR
   TF_XylR = (XYL_ex^n_XylR)/(XYL_ex^n_XylR+K_XylR^n_XylR);
  
%% Kinetic equations
 % PTS
  % PTS1
    v_PTS1_f = PTS1_k1 * PEP * EIIA;
    v_PTS1_r = PTS1_km1 * PYR * EIIA_P;
    v_PTS1 = v_PTS1_f - v_PTS1_r;
  % PTS4
    if ptsG_mutant
        v_PTS4 = 0.0;
    else
        v_PTS4 = (1.0+TF_CrpcAMP) * (k_G6P^n_G6P/(k_G6P^n_G6P+G6P^n_G6P)) * PTS4_Vmax * EIIA_P * GLC_ex / ((PTS4_KEIIA + EIIA_P)*(PTS4_Kglc + GLC_ex));
    end
 % Non-PTS
  % NPTS
    v_NPTS = (1.0+TF_CrpcAMP) * NPTS_Vmax * GLC_ex / (NPTS_Ks + (1.0+(EIIA/NPTS_Ki))*GLC_ex);
 % Glycolysis
  % Glk
    v_Glk = ( Glk_Vmax * GLCin ) / ( (1.0+(G6P/Glk_KI)) * (Glk_Ks+GLCin) );
  % Pgi
    if pgi_mutant
        v_Pgi = 0.0;
    else
        v_Pgi = Pgi_Vmax * (G6P - F6P/Pgi_Keq) / (KPgi_G6P * (1.0 + F6P/(KPgi_F6P*(1.0+PG6/KPgi_F6P_6PGinh)) + PG6/KPgi_G6P_6PGinh) + G6P);
    end
  % Pfk
    v_Pfk = (1.0-TF_Cra) * Pfk_Vmax * (F6P/Pfk_Kg6p) * (1+F6P/Pfk_Kg6p)^(Pfk_n-1) / ((1+F6P/Pfk_Kg6p)^Pfk_n+Pfk_L*(1+PEP/Pfk_Kpep)^Pfk_n);
  % Fba
    v_Fba = (1.0-TF_Cra) * (Fba_Vmax_f*FBP/Fba_Kfbp-Fba_Vmax_r*PG3/Fba_Kpg3) / (1+FBP/Fba_Kfbp+PG3/Fba_Kpg3);
  % L_Emp
    v_L_Emp = (1.0-TF_Cra) * (L_Emp_Vmax_f*PG3/L_Emp_Kpg3-L_Emp_Vmax_r*PEP/L_Emp_Kpep) / (1+PG3/L_Emp_Kpg3+PEP/L_Emp_Kpep);
  % Pyk
    v_Pyk = (1.0-TF_Cra) * Pyk_Vmax * (PEP/Pyk_Kpep) * (1+PEP/Pyk_Kpep)^(Pyk_n-1) / ((1+PEP/Pyk_Kpep)^Pyk_n+Pyk_L/(1+FBP/Pyk_Kfbp)^Pyk_n);
  % PDH
    v_PDH = ((1.0-TF_PdhR)*(1.0-TF_ArcA)) * PDH_Vmax * PYR / PDH_Kpyr*(1+PYR/PDH_Kpyr)^(PDH_n-1)/((1+PYR/PDH_Kpyr)^PDH_n+PDH_L*(1+GLX/PDH_Kglx+PYR/PDH_KpyrI)^PDH_n);
 % PP pathway
  % Rpe
    v_Ru5P = Ru5P_Vmax * (Ribu5-(Xyl5/Ru5P_Keq));
  % Rpi
    v_R5PI = R5PI_Vmax * (Ribu5-(Rib5/R5PI_Keq));
  % TktA
    v_TKa = TKa_Vmax * (Rib5*Xyl5-((S7P*PG3)/TKa_Keq));
  % TktB
    v_TKb = TKb_Vmax * (Xyl5*E4P-((F6P*PG3)/TKb_Keq));
  % Tal
    v_TA = TA_Vmax * (PG3*S7P-((E4P*F6P)/TA_Keq));
 % Fermentative pathway
  % LDH
    v_LDH = Vmax_LDH * (NADH^n_NADH_LDH/(Km_NADH_LDH^n_NADH_LDH + NADH^n_NADH_LDH)) * (PYR^n_PYR_LDH/(Km_PYR_LDH^n_PYR_LDH + PYR^n_PYR_LDH));
 % Pfl
    v_Pfl = ((TF_Fnr+TF_ArcA)*Vmaxf_Pfl*PYR*CoA)/((PYR*CoA+Kpyr_Pfl*CoA+Kcoa_Pfl*PYR))...
            - ((TF_Fnr+TF_ArcA)*Vmaxr_Pfl*ACoA*FOR)/(ACoA*FOR+Kacoa_Pfl*FOR+Kfor_Pfl*ACoA);        
 % ALDH and ADH 
  % ALDH
    v_ALDH = (Vmax_ALDH/(Kacoa_ALDH*Knadh_ALDH))*(ACoA*NADH-((CoA*NAD*AcAld)/Keq_ALDH))/((1.0+(NAD/Knad_ALDH)+(NADH/Knadh_ALDH))*(1.0+(ACoA/Kacoa_ALDH)+(CoA/Kcoa_ALDH)+(AcAld/Kacald_ALDH)+((AcAld*CoA)/(Kacald_ALDH*Kcoa_ALDH))));
  % ADH
    v_ADH = ((Vmax_ADH/(Kacald_ADH*Knadh_ADH))*(AcAld*NADH-((ETH*NAD)/Keq_ADH)))/((1.0+(NAD/Knad_ADH)+(NADH/Knadh_ADH))*(1.0+(AcAld/Kacald_ADH)+(ETH/Keth_ADH)));
% Acetate formation/consumption
  % PTACK
    v_PTACK = (1.0+TF_ArcA) * PTACK_Vmax * (ACoA/PTACK_Kacoa) * (1+ACoA/PTACK_Kacoa)^(PTACK_n-1) / ((1+ACoA/PTACK_Kacoa)^PTACK_n+PTACK_L/(1+PYR/PTACK_Kpyr)^PTACK_n);    
  % Acs
    v_Acs = (1.0-TF_ArcA)*(1.0-TF_Fnr)*(1.0+TF_CrpcAMP) * Acs_Vmax * ACT_ex / (ACT_ex + Acs_Kact);
% TCA cycle
  % CS
    v_CS = ((1.0+TF_CrpcAMP)*(1.0-TF_ArcA)) * CS_Vmax * OAA * ACoA / ((1+AKG/CS_Kakg)*CS_Koaaacoa*CS_Kacoa + CS_Kacoa*OAA + (1+AKG/CS_Kakg)*CS_Koaa*ACoA + OAA*ACoA);
  % ICDH
    v_ICDH = ((1.0+TF_Cra)*(1.0-TF_ArcA)) * (OAA^1.0/(OAA^1.0+K_OAA^1.0)) * ICDH_Vmax * (ICT/ICDH_Kict) * (1+ICT/ICDH_Kict)^(ICDH_n-1) / ((1+ICT/ICDH_Kict)^ICDH_n+ICDH_L*(1+PEP/ICDH_Kpep)^ICDH_n);
  % KGDH
    v_KGMAL = ((1.0+TF_CrpcAMP)*(1.0-TF_ArcA)*(1.0-TF_Fnr)) * KGMAL_Vmax * AKG / (AKG + KGMAL_Kakg);
  % SDH
    v_SDH = ((1.0-TF_Fnr)*(1.0-TF_ArcA)*(1.0+TF_CrpcAMP))*(Vmaxf_SDH*SUC/Ksuc_SDH)/(1.0+(SUC/Ksuc_SDH)+(MAL/Kfum_SDH));  
  % Frd
    v_FRD = (TF_Fnr)*(Vmaxr_SDH*MAL/Kfum_FRD)/(1.0+(SUC/Ksuc_FRD)+(MAL/Kfum_FRD));
  % MDH
    MDH_numerator = Vmaxf_MDH*MAL*NAD/(K_mal_MDH*K_nad_MDH) - Vmaxr_MDH*OAA*NADH/(K_oaa_MDH*K_nadh_MDH);
    MDH_denominator = (1.0+MAL/K_mal_MDH+OAA/K_oaa_MDH)*(1.0+NAD/K_nad_MDH+NADH/K_nadh_MDH);
    v_MDH = (1.0+TF_CrpcAMP)*(MDH_numerator/MDH_denominator);
 % Anaplerotic reaction
  % Ppc
    v_Ppc = (1.0-TF_Cra) * Ppc_Vmax * (PEP/Ppc_Kpep) * (1+PEP/Ppc_Kpep)^(Ppc_n-1) / ((1+PEP/Ppc_Kpep)^Ppc_n+Ppc_L/(1+FBP/Ppc_Kfbp+ACoA/Ppc_Kacoa)^Ppc_n);
 % Glyoxylate pathways
  % Icl
    if TF_Cra > TF_CrpcAMP   % Overriding regulatory activity of Cra over CRP (Kim et al., 2018).
       v_Icl = ((1.0+TF_Cra)*(1.0-TF_IclR)) * Icl_Vmax * (ICT/Icl_Kict) * (1+ICT/Icl_Kict)^(Icl_n-1) / ((1+ICT/Icl_Kict)^Icl_n+Icl_L*(1+PEP/Icl_Kpep+PG3/Icl_Kpg3+AKG/Icl_Kakg)^Icl_n);   
    else
       v_Icl = ((1.0+TF_Cra)*(1.0-TF_IclR)*(1.0-TF_CrpcAMP)) * Icl_Vmax * (ICT/Icl_Kict) * (1+ICT/Icl_Kict)^(Icl_n-1) / ((1+ICT/Icl_Kict)^Icl_n+Icl_L*(1+PEP/Icl_Kpep+PG3/Icl_Kpg3+AKG/Icl_Kakg)^Icl_n);   
    end
  % MS
    if TF_Cra > TF_CrpcAMP   % Overriding regulatory activity of Cra over CRP (Kim et al., 2018).
       v_MS = ((1.0+TF_Cra)*(1.0-TF_IclR)) * MS_Vmax * GLX * ACoA / (MS_Kglxacoa * MS_Kacoa + MS_Kacoa * GLX + MS_Kglx * ACoA + GLX * ACoA);
    else
       v_MS = ((1.0+TF_Cra)*(1.0-TF_IclR)*(1.0-TF_CrpcAMP)) * MS_Vmax * GLX * ACoA / (MS_Kglxacoa * MS_Kacoa + MS_Kacoa * GLX + MS_Kglx * ACoA + GLX * ACoA);
    end
 % Gluconeogenesis
  % Fbp
    v_Fdp = (1.0+TF_Cra) * Fdp_Vmax * (FBP/Fdp_Kfbp) * (1+FBP/Fdp_Kfbp)^(Fdp_n-1) / ((1+FBP/Fdp_Kfbp)^Fdp_n+Fdp_L/(1+PEP/Fdp_Kpep)^Fdp_n);
  % Pps
    v_Pps = (1.0+TF_Cra+TF_CrpcAMP) * Pps_Vmax * (PYR/Pps_Kpyr) * (1+PYR/Pps_Kpyr)^(Pps_n-1) / ((1+PYR/Pps_Kpyr)^Pps_n+Pps_L*(1+PEP/Pps_Kpep)^Pps_n);
  % Pck
    v_Pck = (1.0+TF_Cra+TF_CrpcAMP) * Pck_Vmax * OAA / (OAA+Pck_Koaa*(1+PEP/Pck_Kpep));    
  % Mez
    v_Mez = ((1.0+TF_CrpcAMP)*(1.0-TF_Cra)) * Mez_Vmax * (MAL^Mez_n) * NADP / (((Mez_Kmal^Mez_n)+(MAL^Mez_n))*(Mez_Knadp+NADP));
  % Sfc
    v_Sfc = (1.0+TF_CrpcAMP) * Sfc_Vmax * (MAL^Sfc_n) * NAD / (((Sfc_Kmal^Sfc_n)+(MAL^Sfc_n))*(Sfc_Knad+NAD));
  % SUC transport
    v_SUC_trans = SUC_trans_Vmax * SUC / (SUC_trans_Km_suc+SUC);
 % Xylose pathway
  % XT
    v_XT = (TF_CrpcAMP+TF_XylR) * XT_Vmax * XYL_ex / (XT_Km_Xyl_ex+(1.0+EIIA/XT_Ki_EIIA)*XYL_ex);    
  % Xyi
    v_Xyi = (TF_CrpcAMP+TF_XylR) * Xyi_Vmax * XYLin / (Xyi_Km_Xyl+XYLin);
  % Xyk
    v_Xyk = (TF_CrpcAMP+TF_XylR) * Xyk_Vmax * Xylu * ATP / (Xyk_Km_Xylu*Xyk_Km_ATP + Xyk_Km_ATP*Xylu + Xyk_Km_Xylu*ATP + Xylu*ATP);    
 % ED pathway
  % Edd
    Q_pH_Edd = (1.0+2*10.0^(pHm_Edd-pK_Edd)) / (1.0+(10.0^(pH-pK_Edd))+(10.0^(2.0*pHm_Edd-pH-pK_Edd)));
    v_Edd = Edd_Vmax * Q_pH_Edd * (PG6 - KDPG/Edd_Keq) / (KEdd_PG6 + PG6 + (KEdd_PG6/KEdd_KDPG)*KDPG);
  % Eda
    Q_pH_Eda = (1.0+2*10.0^(pHm_Eda-pK_Eda)) / (1.0+(10.0^(pH-pK_Eda))+(10.0^(2.0*pHm_Eda-pH-pK_Eda)));
    v_Eda = Eda_Vmax * Q_pH_Eda * (KDPG - (PG3*PYR)/Eda_Keq)/(KEda_KDPG + KDPG + KEda_KDPG*((PYR/KEda_PYR) + (PG3/KEda_PG3) + (PYR*PG3/(KEda_PYR*KEda_PG3))) ); 
 % Cya
    v_Cya = Cya_Vmax * EIIA_P / (EIIA_P + Cya_KEIIA);
 % cAMPdegr
    v_cAMPdegr = cAMPdegr_Vmax * cAMP / (cAMP + cAMPdegr_KcAMP);
 % cAMP-Crp
    v_TF_cAMPCrp = TF_cAMPCrp_scale * ((Crp+CrpcAMP)*cAMP^TF_cAMPCrp_n/(cAMP^TF_cAMPCrp_n+TF_cAMPCrp_Kcamp^TF_cAMPCrp_n)-CrpcAMP);
 % Cra-FBP
    v_TF_CraFBP = TF_CraFBP_scale * ((Cra+CraFBP)*FBP^TF_CraFBP_n/(FBP^TF_CraFBP_n+TF_CraFBP_Kfbp^TF_CraFBP_n)-CraFBP);
 % PdhR-PYR
    v_TF_PdhRPYR = TF_PdhRPYR_scale * ((PdhR+PdhRPYR)*PYR^TF_PdhRPYR_n/(PYR^TF_PdhRPYR_n+TF_PdhRPYR_Kpyr^TF_PdhRPYR_n)-PdhRPYR);
 % Nuo
    v_Nuo = v_Nuo_max * (1.0-TF_ArcA) * (1.0-TF_Fnr) * (Q/(Km_Nuo_Q+Q)) * (NADH/(Km_Nuo_e2H2+NADH));
 % Ndh
    v_Ndh = v_Ndh_max * (1.0-TF_Fnr) * (Q/(Km_Ndh_Q+Q)) * (NADH/(Km_Ndh_e2H2+NADH));
 % Cyo
    v_Cyo = v_Cyo_max * (1.0-TF_ArcA) * (1.0-TF_Fnr) * (O2/(Km_Cyo_O2+O2)) * (QH2/(Km_Cyo_QH2+QH2));
 % Cyd
    v_Cyd = v_Cyd_max * (1.0+TF_ArcA) * (1.0-TF_Fnr) * (O2/(Km_Cyd_O2+O2)) * (QH2/(Km_Cyd_QH2+QH2));
% Glucose uptake rate
   v_GLC_uptake = Mw_GLC * uc * OD * (v_PTS4 + v_NPTS) - (S_f_GLCex - GLC_ex) * D;
% Xylose uptake rate
   v_XYL_uptake = Mw_XYL * uc * OD * v_XT - (S_f_XYLex - XYL_ex) * D;
% Acetate excretion rate
   v_ACT_excretion = Mw_ACT * uc * OD * v_PTACK;
% Acetate uptake rate
   v_ACT_uptake = Mw_ACT * uc * OD * v_Acs + ACT_ex * D;
% Lactate excretion rate
   v_LAC_excretion = Mw_LAC * uc * OD * v_LDH - LAC * D;
% Formate excretion rate
   v_FOR_excretion = Mw_FOR * uc * OD * v_Pfl - FOR * D;
% Ethanol excretion rate
   v_ETH_excretion = Mw_ETH * uc * OD * v_ADH - ETH * D;
% Succinate excretion rate
   v_SUC_excretion = Mw_SUC * uc * OD * v_SUC_trans - SUC_ex * D;

%% Specific ATP production rate
 OP = (4.0*v_Nuo + 4.0*v_Cyo + 2.0*v_Cyd)/Ratio_H_ATP;
 v_ATP = OP + v_L_Emp + v_Pyk + v_PTACK + v_KGMAL - v_Pfk - v_Pps - v_Pck - v_Acs - v_Xyk - v_Glk - v_XT;

 % Specific growth rate
   mu =  k_ATP * v_ATP;
   if mu < 0.0
       mu = 0.0;
   end
   
%% G6PDH and PGDH
% G6PDH
   v_G6PDH = (1.0-TF_Cra) * (kk_G6PDH+mu*k_G6PDH) * G6PDH_Vmax * G6P * NADP / ((G6P+G6PDH_Kg6p)*(1.0+(NADPH/G6PDH_Knadph_g6pinh))*(G6PDH_Knadp*(1.0+(NADPH/G6PDH_Knadph_nadphinh))+NADP));
% PGDH
   v_PGDH = (PGDH_Vmax * (kk_PGDH+mu*k_PGDH) * PG6 * NADP) / ((PG6+PGDH_K6pg)*(NADP+PGDH_Knadp*(1.0+(NADPH/PGDH_Knadphinh))*(1.0+(ATP/PGDH_Katpinh))));
% Specific NADPH production rate
   v_NADPH = v_Mez + v_G6PDH + v_PGDH + v_ICDH;
% Specific NADH production rate
   v_NADH = v_L_Emp + v_PDH + v_KGMAL + v_MDH + v_Sfc - v_LDH - v_ALDH - v_ADH - v_Nuo - v_Ndh;
   % Specific CO2 production rate
   v_CO2 = v_PDH + v_ICDH + v_KGMAL + v_Mez + v_Pck + v_PGDH - v_Ppc;
% Synthesis of QH2
   v_syn_QH2 = mu * p_syn_QH2;
% Biosynthesis
  % G6P
    v_Bio_G6P = k_Bio_G6P * mu * G6P + b_Bio_G6P * G6P;
  % F6P
    v_Bio_F6P =  k_Bio_F6P * mu * F6P + b_Bio_F6P * F6P;
  % GAP/`/2PG
    v_Bio_PG3 = k_Bio_PG3 * mu * PG3 + b_Bio_PG3 * PG3;
  % PEP
    v_Bio_PEP = k_Bio_PEP * mu * PEP + b_Bio_PEP * PEP;
  % PYR
    v_Bio_PYR = k_Bio_PYR * mu * PYR + b_Bio_PYR * PYR;
  % AcCoA
    v_Bio_ACoA = k_Bio_ACoA * mu * ACoA + b_Bio_ACoA * ACoA;
  % R5P
    v_Bio_R5P = k_Bio_R5P * mu * Rib5 + b_Bio_R5P * Rib5;
  % E4P
    v_Bio_E4P = k_Bio_E4P * mu * E4P + b_Bio_E4P * E4P;
  % aKG
    v_Bio_AKG = k_Bio_AKG * mu * AKG + b_Bio_AKG * AKG;
  % OAA
    v_Bio_OAA = k_Bio_OAA * mu * OAA + b_Bio_OAA * OAA;

%% Model_equations

if called_by_ode15s
   dx(1,1)  = OD * (mu - D);                                     % OD
   dx(2,1)  = - v_GLC_uptake;                                    % GLC_ex
   dx(3,1)  = - v_XYL_uptake;                                    % XYL_ex
   dx(4,1)  = v_ACT_excretion - v_ACT_uptake;                    % ACT_ex
   dx(32,1) = v_LAC_excretion;                                   % LAC
   dx(35,1) = v_FOR_excretion;                                   % FOR
   dx(34,1) = v_ETH_excretion;                                   % ETH
   dx(39,1) = v_SUC_excretion;                                   % SUC_ex
 % Glycolysis
   dx(24,1) = (v_NPTS) - (v_Glk) - mu * GLCin;                                                                   % GLCin
   dx(42,1) = (v_PTS4 + v_Glk) - (v_Pgi + v_G6PDH + v_Bio_G6P) - mu * G6P;                                       % G6P
   dx(5,1)  = (v_Pgi + v_Fdp + v_TKb + v_TA) - (v_Pfk + v_Bio_F6P) - mu * F6P;                                   % F6P
   dx(6,1)  = (v_Pfk) - (v_Fba + v_Fdp) - mu * FBP;                                                              % FBP
   dx(7,1)  = (2.0*v_Fba + v_TKa + v_TKb + v_Eda) - (v_L_Emp + v_TA + v_Bio_PG3) - mu * PG3;                     % GAP/DHAP
   dx(8,1)  = (v_L_Emp + v_Pck + v_Pps) - (v_Pyk + v_Ppc + v_PTS1 + v_Bio_PEP) - mu * PEP;                       % PEP
   dx(9,1)  = (v_Pyk + v_Mez + v_Sfc + v_PTS1 + v_Eda) - (v_PDH + v_Pps + v_Bio_PYR + v_LDH + v_Pfl) - mu * PYR; % PYR
   dx(10,1) = (v_PDH + v_Acs + v_Pfl) - (v_CS + v_PTACK + v_MS + v_Bio_ACoA + v_ALDH) - mu * ACoA;               % ACoA
   dx(33,1) = (v_ALDH) - (v_ADH) - mu * AcAld;                                                                   % AcAld
  % PP pathway
   dx(16,1) = (v_G6PDH) - (v_PGDH + v_Edd) - mu * PG6;                                                           % PGL/6PG
   dx(17,1) = (v_PGDH) - (v_Ru5P + v_R5PI) - mu * Ribu5;                                                         % Ribu5
   dx(19,1) = (v_R5PI) - (v_TKa + v_Bio_R5P) - mu * Rib5;                                                        % Rib5
   dx(18,1) = (v_Ru5P + v_Xyk) - (v_TKa + v_TKb) - mu * Xyl5;                                                    % Xyl5
   dx(20,1) = (v_TKa) - (v_TA) - mu * S7P;                                                                       % S7P
   dx(21,1) = (v_TA) - (v_TKb + v_Bio_E4P) - mu * E4P;                                                           % E4P
 % TCA cycle
   dx(11,1) = (v_CS) - (v_ICDH + v_Icl) - mu * ICT;                                                              % CIT/ICIT
   dx(12,1) = (v_ICDH) - (v_KGMAL + v_Bio_AKG) - mu * AKG;                                                       % AKG
   dx(31,1) = (v_KGMAL + v_Icl + v_FRD) - (v_SDH + v_SUC_trans) - mu * SUC;                                      % SUC
   dx(13,1) = (v_SDH + v_MS) - (v_MDH + v_Mez + v_Sfc + v_FRD) - mu * MAL;                                       % MAL
   dx(14,1) = (v_MDH +v_Ppc) - (v_CS + v_Pck + v_Bio_OAA) - mu * OAA;                                            % OAA
   dx(15,1) = (v_Icl) - (v_MS) - mu * GLX;                                                                       % GOX
 % Xylose pathway
   dx(22,1) = (v_XT) - (v_Xyi) - mu * XYLin;                                                                     % XYLin
   dx(23,1) = (v_Xyi) - (v_Xyk) - mu * Xylu;                                                                     % Xylu
   dx(25,1) = (v_PTS4) - (v_PTS1);                                                                               % EIIA
   dx(26,1) = (v_PTS1) - (v_PTS4);                                                                               % EIIA_P
   dx(27,1) = (v_Cya) - (v_cAMPdegr) - mu * cAMP;                                                                % cAMP
   dx(28,1) = (v_TF_cAMPCrp) - mu * CrpcAMP;                                                                     % CrpcAMP
   dx(29,1) = (v_TF_CraFBP) - mu * CraFBP;                                                                       % CraFBP
   dx(30,1) = (v_TF_PdhRPYR) - mu * PdhRPYR;                                                                     % PdhRPYR
% Electron transport chain
   dx(36,1) = (v_Nuo + v_Ndh + v_SDH) - (v_Cyo + v_Cyd) + v_syn_QH2 - mu * QH2;                                   % QH2
   dx(37,1) = (v_Cyo + v_Cyd) - (v_Nuo + v_Ndh + v_SDH) - mu * Q;                                                 % Q
   dx(38,1) = (v_L_Emp + v_PDH + v_KGMAL + v_MDH + v_Sfc) - (v_LDH + v_ALDH + v_ADH + v_Nuo + v_Ndh) - mu * NADH; % NADH
% NADPH
   dx(40,1) = v_Mez + v_G6PDH + v_PGDH + v_ICDH - knadph * NADPH - mu * NADPH;                                    % NADPH
% O2   
   dx(41,1) = 0.0;
% KDPG
   dx(43,1) = v_Edd - v_Eda - mu * KDPG;
   
   if t < 0.0
   dx(1,1)  = 0.0;                                   % OD
   dx(2,1)  = 0.0;                                   % GLC_ex
   dx(3,1)  = 0.0;                                   % XYL_ex
   dx(4,1)  = 0.0;                                   % ACT_ex
   dx(32,1) = 0.0;                                   % LAC
   dx(35,1) = 0.0;                                   % FOR
   dx(34,1) = 0.0;                                   % ETH
   dx(39,1) = 0.0;                                   % SUC_ex
   dx(41,1) = 0.0;                                   % O2
   end
      
else
     
   dx = [v_PTS1 v_PTS4 v_NPTS v_Glk v_Cya v_cAMPdegr v_Pfk v_Fdp v_Fba v_L_Emp ...
       v_Pyk v_Pps v_PDH v_PTACK v_Acs v_Icl v_MS v_CS v_ICDH v_KGMAL ...
       v_MDH v_Mez v_Ppc v_Pck v_XT v_Xyi v_Xyk v_G6PDH v_PGDH v_Ru5P ...
       v_R5PI v_TKa v_TKb v_TA v_ATP v_NADH v_NADPH v_CO2 mu v_TF_cAMPCrp ...
       v_TF_CraFBP v_TF_PdhRPYR v_Bio_G6P v_Bio_PG3 v_Bio_PEP v_Bio_PYR v_Bio_ACoA v_Bio_AKG v_Bio_OAA TF_CrpcAMP ...
       TF_Cra TF_PdhR TF_IclR Crp Cra PdhR v_SDH v_FRD v_LDH v_ALDH ...
       v_ADH v_Pfl TF_Fnr TF_ArcA v_PTS1_f v_PTS1_r v_Cyo v_Cyd v_Nuo v_Ndh ...
       v_syn_QH2 NAD v_SUC_trans v_Bio_R5P v_Bio_E4P v_Sfc NADP knadph*mu TF_XylR ...
       v_Pgi v_Bio_F6P v_Edd v_Eda];
   
end




