% Wild Type
% GLC + XYL
% Batch Culturte
% Aerobic

clear all;

pgi_mutant = false;
ptsG_mutant = false;

mutant = [pgi_mutant; ptsG_mutant];

D = 0.0;
S_f_GLCex = 0.0;
S_f_XYLex = 0.0;

Time_Final = 20 * 3600; % [s]
GLC_ex_input = 5.0;     % [g/l]
XYL_ex_input = 5.0;     % [g/l]

a = 40.0;

IC = Initial_Concentration(a);
IC(1,1) = 0.032;
IC(1,2) = GLC_ex_input;
IC(1,3) = XYL_ex_input;

called_by_ode15s = true;
options=odeset('RelTol',1e-5,'AbsTol',1e-20);

[t_0, x_0] = ode15s(@Dynamic_behavior,[-10.0*3600.0 0.0],IC,options,mutant,D,S_f_GLCex,S_f_XYLex,a,called_by_ode15s);
IC_0 = x_0(end,:);

[t, x] = ode15s(@Dynamic_behavior,[0.0 Time_Final],IC_0,options,mutant,D,S_f_GLCex,S_f_XYLex,a,called_by_ode15s);

called_by_ode15s = false;
f = zeros(size(x,1),83);
for indx = 1:size(x,1)
    f(indx,:) = Dynamic_behavior(0,x(indx,:),mutant,D,S_f_GLCex,S_f_XYLex,a,called_by_ode15s);
end

t = (1.0/3600.0)*t;
f = 3600.0*f;

OD = x(:,1);
GLC_ex = x(:,2);
XYL_ex = x(:,3);
ACT_ex = x(:,4);
F6P = x(:,5);
FBP = x(:,6);
PG3 = x(:,7);
PEP = x(:,8);
PYR = x(:,9); 
ACoA = x(:,10);
ICT = x(:,11);
AKG = x(:,12);
MAL = x(:,13);
OAA = x(:,14);
GLX = x(:,15);
PG6 = x(:,16);
Ribu5 = x(:,17);
Xyl5 = x(:,18);
Rib5 = x(:,19);
S7P = x(:,20);
E4P = x(:,21);
XYLin = x(:,22);
Xylu = x(:,23);
GLCin = x(:,24);
EIIA = x(:,25);
EIIA_P = x(:,26);
cAMP = x(:,27);
CrpcAMP = x(:,28);
CraFBP = x(:,29);
PdhRPYR = x(:,30);
SUC = x(:,31);
LAC = x(:,32);
AcAld = x(:,33);
ETH = x(:,34);
FOR = x(:,35);
QH2 = x(:,36);
Q = x(:,37);
NADH = x(:,38);
SUC_ex = x(:,39);
NADPH = x(:,40);
O2 = x(:,41);
G6P = x(:,42);
KDPG = x(:,43);

v_PTS1 = f(:,1);
v_PTS4 = f(:,2);
v_NPTS = f(:,3);
v_Glk = f(:,4);
v_Cya = f(:,5);
v_cAMPdegr = f(:,6);
v_Pfk = f(:,7);
v_Fdp = f(:,8);
v_Fba = f(:,9);
v_L_Emp = f(:,10);
v_Pyk = f(:,11);
v_Pps = f(:,12);
v_PDH = f(:,13);
v_PTACK = f(:,14);
v_Acs = f(:,15);
v_Icl = f(:,16);
v_MS = f(:,17);
v_CS = f(:,18);
v_ICDH = f(:,19);
v_KGMAL = f(:,20);
v_MDH = f(:,21);
v_Mez = f(:,22);
v_Ppc = f(:,23);
v_Pck = f(:,24);
v_XT = f(:,25);
v_Xyi = f(:,26);
v_Xyk = f(:,27);
v_G6PDH = f(:,28);
v_PGDH = f(:,29);
v_Ru5P = f(:,30);
v_R5PI = f(:,31);
v_TKa = f(:,32);
v_TKb = f(:,33);
v_TA = f(:,34);
v_ATP = f(:,35);
v_NADH = f(:,36);
v_NADPH = f(:,37);
v_CO2 = f(:,38);
mu = f(:,39);
v_TF_cAMPCrp = f(:,40); 
v_TF_CraFBP = f(:,41);
v_TF_PdhRPYR = f(:,42);
v_Bio_G6P = f(:,43);
v_Bio_PG3 = f(:,44);
v_Bio_PEP = f(:,45);
v_Bio_PYR = f(:,46);
v_Bio_ACoA = f(:,47);
v_Bio_AKG = f(:,48);
v_Bio_OAA = f(:,49);
TF_CrpcAMP = f(:,50)./3600.0;
TF_Cra = f(:,51)./3600.0;
TF_PdhR = f(:,52)./3600.0;
TF_IclR = f(:,53)./3600.0;
Crp = f(:,54)./3600.0;
Cra = f(:,55)./3600.0;
PdhR= f(:,56)./3600.0;
v_SDH = f(:,57);
v_FRD = f(:,58);
v_LDH = f(:,59);
v_ALDH = f(:,60);
v_ADH = f(:,61);
v_Pfl = f(:,62);
TF_Fnr = f(:,63)./3600.0;
TF_ArcA = f(:,64)./3600.0;
v_PTS1_f = f(:,65);
v_PTS1_r = f(:,66);
v_Cyo = f(:,67);
v_Cyd = f(:,68);
v_Nuo = f(:,69);
v_Ndh = f(:,70);
v_syn_QH2 = f(:,71);
NAD = f(:,72)./3600.0;
v_SUC_trans = f(:,73);
v_Bio_R5P = f(:,74);
v_Bio_E4P = f(:,75);
v_Sfc = f(:,76);
NADP = f(:,77)./3600.0;
v_biosynthesis = f(:,78);
TF_XylR = f(:,79)./3600.0;
v_Pgi = f(:,80);
v_Bio_F6P = f(:,81);
v_Edd = f(:,82);
v_Eda = f(:,83);

%% Matsuo, 2011 [Experimental data]
 Exp_wild_GLC_XYL_time1 = [0.0 2.0 4.0 6.0 8.0 10.0 12.0 14.0 16.0];
 Exp_wild_GLC_XYL_GLC = [5.054945055 4.923076923 3.758241758 0.013186813 0.0 0.0 0.0 0.0 0.0];
 Exp_wild_GLC_XYL_XYL = [4.58127 4.882485 4.51122 4.868475 0.0301215 0.001401 0.001401 0.0 0.0007005];
 Exp_wild_GLC_XYL_time2 = [0.0 4.0 8.0 12.0 16.0];
 Exp_wild_GLC_XYL_ACT = [0.009353589 0.269108404 1.190325726 -0.011977778 0.000523732];
 Exp_wild_GLC_XYL_time3 = [0.0 1.0 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0 10.0 11.0 12.0 13.0 14.0 15.0 16.0];
 Exp_wild_GLC_XYL_Cell = [0.121872986 0.159958294 0.224703318 0.453215166 0.895004739 1.683370616 2.78784455 3.35531564 4.117021801 4.231277725 4.475023697 4.44455545 4.379810427 4.257937441 4.212235071 4.086553555 4.018];   % [g/l]
 figure(1); q1 = plot(t, GLC_ex,'k-','LineWidth',3.0); hold on
 figure(1); q2 = plot(t, XYL_ex,'Color',[1 0.6 0],'LineWidth',3.0); hold on
 figure(1); q3 = plot(t, ACT_ex,'r-','LineWidth',3.0); hold on
 figure(1); q4 = plot(t, 9.5E-07*OD*1.0e+6,'k:','LineWidth',3.0); hold on
 figure(1); plot(Exp_wild_GLC_XYL_time1,Exp_wild_GLC_XYL_GLC,'ko','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',10,'LineWidth',3.0); hold on
 figure(1); plot(Exp_wild_GLC_XYL_time2,Exp_wild_GLC_XYL_ACT,'rd','MarkerEdgeColor','r','MarkerFaceColor','w','MarkerSize',10,'LineWidth',3.0); hold on
 figure(1); plot(Exp_wild_GLC_XYL_time1,Exp_wild_GLC_XYL_XYL,'ks','MarkerEdgeColor',[1 0.6 0],'MarkerFaceColor','w','MarkerSize',10,'LineWidth',3.0); hold on
 figure(1); plot(Exp_wild_GLC_XYL_time3,Exp_wild_GLC_XYL_Cell,'r^','MarkerEdgeColor','k','MarkerFaceColor','w','MarkerSize',10,'LineWidth',3.0); hold on
 legend([q1 q2 q3 q4],'GLC','XYL','ACT','Biomass');
 set(gca,'fontname','arial','fontsize',10,'fontweight','bold','linewidth',1.5,'xlim',[0 Time_Final/3600.0],'xtick',(0:5:Time_Final/3600.0),'ylim', [0 10.0],'ytick',(0:2:10));
 xlabel('Time [h]','fontname','arial','fontweight','bold','fontsize',12);
 ylabel('Concentration [g/l]','fontname','arial','fontweight','bold','fontsize',12);
 set(gcf,'color','white'); hold on
